import paho.mqtt.client as mqtt_client

class mqtt:
    def __init__(self, hostname, port=1883, keepalive=60, qos=2, retain=True):
        self.__hostname = hostname
        self.__port = port
        self.__keepalive = keepalive
        self.__client = mqtt_client.Client()
        self.__is_connected = False
        self.__qos = qos
        self.__retain = retain

    def __on_connect(self, client, data, flags, result):
        print "Connected: " + str(result)

    def connect(self):
        if not self.__is_connected:
            self.__client.on_connect = self.__on_connect
            result = self.__client.connect(self.__hostname, self.__port, self.__keepalive)
            result |= self.__client.loop_start()
            if 0 == result:
                self.__is_connected = True
                return True
        return False

    def disconnect(self):
        if self.__is_connected:
            self.__client.loop_stop()
            self.__client.disconnect()
            return True
        return False

    def transmit(self, topic, payload):
        if not self.__is_connected:
            return False
        result = self.__client.publish(topic, payload, self.__qos, self.__retain)
        if result == 0:
            return True
        return False
